local mapMod = foundation.createMod();

-- registering map files
mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")

-- register custom map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MY_MAP_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -47,
	MaxHeight = 153,
	VillagePathList = {
		{
			Entrance = { 579, 0, 1008 },
			Exit = { 1022, 0, 665 },
		},
		{
			Entrance = { 4, 0, 350 },
			Exit = { 154, 0, 1 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 181 , 14 , 859 },
			Orientation = { 0.0, -0.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 201 , 11 , 842 },
			Orientation = { 0.0, -45.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 312 , 50 , 926 },
			Orientation = { 0.0, -48.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 636 , 44 , 492 },
			Orientation = { 0.0, -89.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 642 , 40 , 481 },
			Orientation = { 0.0, -152.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 891 , 12 , 114 },
			Orientation = { 0.0, -78.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 65 , 26 , 751 },
			Orientation = { 0.0, -180.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 58 , 26 , 231 },
			Orientation = { 0.0, 20.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 841 , 19 , 911 },
			Orientation = { 0.0, -90.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 922 , 15 , 895 },
			Orientation = { 0.0, 20.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 990 , 13 , 814 },
			Orientation = { 0.0, -120.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 991 , 24 , 552 },
			Orientation = { 0.0, -10.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 990 , 14 , 249 },
			Orientation = { 0.0, 132.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 966 , 52 , 25 },
			Orientation = { 0.0, -45.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 87 , 43 , 68 },
			Orientation = { 0.0, 90.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 85 , 47 , 60 },
			Orientation = { 0.0, -50.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 466 , 39 , 364 },
			Orientation = { 0.0, -30.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 46 , 109 , 950 },
			Orientation = { 0.0, -30.0 , 0.0},
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.6,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.6,
							Max = 1.0
					},
						ColorRange = {
							Min = { 0.729400634765625,0.6784210205078125,0.04705810546875,1 },
							Max = { 0.9607696533203125,0.6588134765625,0.0941162109375,1 }
--							Min = { 0.8,0.8,0.8,1 },
--							Max = { 1,1,1,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.6,
							Max = 1.4
					},
						ColorRange = {
							Min = { 0.17254638671875,0.321563720703125,0.0039215087890625,1 },
							Max = { 0.337249755859375,0.384307861328125,0.01568603515625,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
